SystemOrganization addCategory: #TinyTower!

DialogWindow subclass: #BitizenDialogWindow
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenDialogWindow methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 23:56'!
initialExtent
	^ 270 @ 245! !

!BitizenDialogWindow methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 23:25'!
model
	^morph model! !

!BitizenDialogWindow methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 23:23'!
model: aBitizen
	morph model: aBitizen! !

!BitizenDialogWindow methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 23:22'!
newContentMorph
	morph := BitizenMorph new beSpaceFilling.
	^morph! !

Morph subclass: #BitizenMorph
	instanceVariableNames: 'model dreamJobListModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenMorph commentStamp: '' prior: 0!
A BitizenController is xxxxxxxxx.

Instance Variables
	model:		<Object>

model
	- xxxxx
!

!BitizenMorph methodsFor: 'bitizen name' stamp: 'HwaJong 2/23/2014 22:42'!
bitizenName
	^model
		ifNil: [ '' ]
		ifNotNil: [ model bitName ]! !

!BitizenMorph methodsFor: 'bitizen name' stamp: 'HwaJong 2/23/2014 22:42'!
bitizenName: aString
	model bitName: aString.
	self changed: #bitizenName! !

!BitizenMorph methodsFor: 'droplist' stamp: 'HwaJong 2/23/2014 22:42'!
creativeDropList
	^self dropListZeroToNine! !

!BitizenMorph methodsFor: 'get index' stamp: 'HwaJong 2/23/2014 22:42'!
creativeDropListIndex
	^self dropListIndexWithAbilityGetter: #creativeAbility! !

!BitizenMorph methodsFor: 'set index' stamp: 'HwaJong 2/23/2014 22:42'!
creativeDropListIndex: anInteger 
	self dropListIndex: anInteger abilitySetter: #creativeAbility:! !

!BitizenMorph methodsFor: 'dream job' stamp: 'HwaJong 2/25/2014 00:50'!
dreamJobDropList
	^self dreamJobListModel list collect: [ :each| each ifNil: [ 'nil' ] ifNotNil: [each jobName] ]! !

!BitizenMorph methodsFor: 'dream job' stamp: 'HwaJong 2/23/2014 23:36'!
dreamJobDropListIndex
	^self dreamJobListModel selectionIndex! !

!BitizenMorph methodsFor: 'dream job' stamp: 'HwaJong 2/23/2014 23:41'!
dreamJobDropListIndex: anInteger 
	self dreamJobListModel selectionIndex: anInteger.
	model dreamJob: self dreamJobListModel selection! !

!BitizenMorph methodsFor: 'dream job' stamp: 'HwaJong 2/23/2014 23:35'!
dreamJobListModel
	^dreamJobListModel setDefault: #dreamJobListModelDefault for: self withSetter: #dreamJobListModel:! !

!BitizenMorph methodsFor: 'dream job' stamp: 'HwaJong 2/23/2014 23:36'!
dreamJobListModel: aTGListModel 
	dreamJobListModel := aTGListModel! !

!BitizenMorph methodsFor: 'dream job' stamp: 'HwaJong 2/23/2014 23:36'!
dreamJobListModelDefault
	^TGListModel new! !

!BitizenMorph methodsFor: 'set index' stamp: 'HwaJong 2/23/2014 22:42'!
dropListIndex: anInteger abilitySetter: aSymbol
	model perform: aSymbol with: anInteger-1! !

!BitizenMorph methodsFor: 'get index' stamp: 'HwaJong 2/23/2014 22:42'!
dropListIndexWithAbilityGetter: aSymbol
	^(model isNil or: [(model perform: aSymbol) isNil])
		ifTrue: [0]
		ifFalse: [ (model perform: aSymbol)+1 ]! !

!BitizenMorph methodsFor: 'droplist' stamp: 'HwaJong 2/23/2014 22:42'!
dropListZeroToNine
	^(0 to: 9) asArray! !

!BitizenMorph methodsFor: 'droplist' stamp: 'HwaJong 2/23/2014 22:42'!
foodDropList
	^self dropListZeroToNine! !

!BitizenMorph methodsFor: 'get index' stamp: 'HwaJong 2/23/2014 22:42'!
foodDropListIndex
	^self dropListIndexWithAbilityGetter: #foodAbility! !

!BitizenMorph methodsFor: 'set index' stamp: 'HwaJong 2/23/2014 22:42'!
foodDropListIndex: anInteger 
	self dropListIndex: anInteger abilitySetter: #foodAbility:! !

!BitizenMorph methodsFor: 'initialization' stamp: 'HwaJong 3/1/2014 22:09'!
initialize
	|q|
	super initialize.
	self color: Color transparent.
	self beShrinkWrapping.
	self layoutPolicy: ProportionalLayout new.
	q := QuickPrototyping for: self.
	
	{ 
		{ q staticLabel: 'name'. q text: #bitizenName }.
		{ q staticLabel: 'dream job'. q dropList: #dreamJob }.
		{ q staticLabel: 'food'. q dropList: #food }.
		{ q staticLabel: 'service'. q dropList: #service }.
		{ q staticLabel: 'recreation'. q dropList: #recreation }.
		{ q staticLabel: 'retail'. q dropList: #retail }.
		{ q staticLabel: 'creative'. q dropList: #creative }.
	}
		keysAndValuesDo:  [:rowIndex :array| 
			self addMorph: (array first) fullFrame: (LayoutFrame fractions: (0@0 corner: 0@0) offsets: (0@(25*(rowIndex-1)) corner: 100@(25*rowIndex))).
			self addMorph: (array second) fullFrame: (LayoutFrame fractions: (0@0 corner: 0@0) offsets: (100@(25*(rowIndex-1)) corner: 250@(25*rowIndex)))].
	"self extent: 800@800."! !

!BitizenMorph methodsFor: 'accessing' stamp: 'HwaJong 2/23/2014 23:27'!
model
	^model! !

!BitizenMorph methodsFor: 'accessing' stamp: 'HwaJong 2/25/2014 00:50'!
model: aBitizen 
	model := aBitizen.
	self changed: #foodDropListIndex.
	self changed: #serviceDropListIndex.
	self changed: #recreationDropListIndex.
	self changed: #retailDropListIndex.
	self changed: #creativeDropListIndex.
	self changed: #bitizenName.
	
	self dreamJobListModel 
		list: ({nil},(model game jobs asSortedCollection: (UnarySortDescriptor ascendingBy: #jobName)));
		selection: model dreamJob.
	self changed: #dreamJobDropList.
	self changed: #dreamJobDropListIndex.! !

!BitizenMorph methodsFor: 'droplist' stamp: 'HwaJong 2/23/2014 22:42'!
recreationDropList
	^self dropListZeroToNine! !

!BitizenMorph methodsFor: 'get index' stamp: 'HwaJong 2/23/2014 22:42'!
recreationDropListIndex
	^self dropListIndexWithAbilityGetter: #recreationAbility! !

!BitizenMorph methodsFor: 'set index' stamp: 'HwaJong 2/23/2014 22:42'!
recreationDropListIndex: anInteger 
	self dropListIndex: anInteger abilitySetter: #recreationAbility:! !

!BitizenMorph methodsFor: 'droplist' stamp: 'HwaJong 2/23/2014 22:42'!
retailDropList
	^self dropListZeroToNine ! !

!BitizenMorph methodsFor: 'get index' stamp: 'HwaJong 2/23/2014 22:42'!
retailDropListIndex
	^self dropListIndexWithAbilityGetter: #retailAbility! !

!BitizenMorph methodsFor: 'set index' stamp: 'HwaJong 2/23/2014 22:42'!
retailDropListIndex: anInteger 
	self dropListIndex: anInteger abilitySetter: #retailAbility:! !

!BitizenMorph methodsFor: 'droplist' stamp: 'HwaJong 2/23/2014 22:42'!
serviceDropList
	^self dropListZeroToNine! !

!BitizenMorph methodsFor: 'get index' stamp: 'HwaJong 2/23/2014 22:42'!
serviceDropListIndex
	^self dropListIndexWithAbilityGetter: #serviceAbility! !

!BitizenMorph methodsFor: 'set index' stamp: 'HwaJong 2/23/2014 22:42'!
serviceDropListIndex: anInteger 
	self dropListIndex: anInteger abilitySetter: #serviceAbility:! !

Announcement subclass: #BitizenNameChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

Object subclass: #FloorController
	instanceVariableNames: 'model ownerController'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

FloorController subclass: #CommercialFloorController2
	instanceVariableNames: 'bitizenListModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:28'!
addBitizenToFloor

	|cb|
	cb := ChooseFromBuilder new.
	cb title: 'select bitizen to employ'.
	model game unemployeedBitizens do: [:each| 
		cb choiceString: each bitName value: 
			[model addBitizen: each.
			self changed: #bitizenListSize.
			self changed: #bitizenListElementAt:] ].
	cb chooseFromValuesTitle.! !

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:55'!
bitizenIsSelected
	^self bitizenListModel hasSelection! !

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:07'!
bitizenListElementAt: anInteger 
	| b |
	b := self bitizenListModel list at: anInteger.
	^{b bitName}! !

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:53'!
bitizenListIndex
	^self bitizenListModel selectionIndex! !

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:09'!
bitizenListIndex: anInteger 
	self bitizenListModel selectionIndex: anInteger.
	self changed: #bitizenListIndex.
	self changed: #bitizenIsSelected. ! !

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:53'!
bitizenListModel
	^bitizenListModel setDefault: #bitizenListModelDefault for: self withSetter: #bitizenListModel:! !

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:54'!
bitizenListModel: aTGListModel 
	bitizenListModel := aTGListModel! !

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:58'!
bitizenListModelDefault
	^model
		ifNil: [ TGListModel new ] 
		ifNotNil: [ TGListModel new list: model bitizenOrderedCollection ]! !

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:54'!
bitizenListSize
	^self bitizenListModel list size! !

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:11'!
canAddBitizen
	^model 
		ifNil: [ false ]
		ifNotNil: [ model bitizenOrderedCollection size < model maxPopulation ]! !

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:12'!
model: aFloor
	model := aFloor.
	self bitizenListModel: nil.
	self changed: #bitizenListSize.
	self changed: #bitizenListElementAt:.
	self changed: #canAddBitizen.! !

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:10'!
morph
	| q |
	q := QuickPrototyping for: self.
	^q column: 
		{q fastMultiList: #bitizen.
		q row: 
			{q button: '+' action: #addBitizenToFloor enabled: #canAddBitizen.
			q button: '-' action: #removeBitizenFromFloor enabled: #bitizenIsSelected.
			q button: 'up' action: #moveUpSelectedBitizen enabled: #bitizenIsSelected.
			q button: 'down' action: #moveDownSelectedBitizen enabled: #bitizenIsSelected.}}! !

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:49'!
moveDownSelectedBitizen
	self bitizenListModel moveSelectionDown.
	self changed: #bitizenListElementAt:! !

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:49'!
moveUpSelectedBitizen
	self bitizenListModel moveSelectionUp.
	self changed: #bitizenListElementAt:! !

!CommercialFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 14:04'!
removeBitizenFromFloor
	| b |
	b := self bitizenListModel selection.
	model removeBitizen: b.
	self model: model! !

!FloorController methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/25/2014 12:25'!
bitizen1Name
	^self bitizenNameAt: 1! !

!FloorController methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/25/2014 12:25'!
bitizen2Name
	^self bitizenNameAt: 2! !

!FloorController methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/25/2014 12:25'!
bitizen3Name
	^self bitizenNameAt: 3! !

!FloorController methodsFor: 'as yet unclassified ' stamp: 'HwaJong 2/25/2014 12:25'!
bitizenChangedAt: anInteger 
	self changed: ('bitizen' , anInteger printString , 'Name') asSymbol.
	ownerController changed: #floorListElementAt:! !

!FloorController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:40'!
bitizenNameAt: anInteger
	"^model 
		ifNil: [ 'no model' ]
		ifNotNil: 
			[(model bitizenArray at: anInteger)
			ifNil: [ '--' ]
			ifNotNil: [:that| that bitName] ]"
	
	^'wack'
	! !

!FloorController methodsFor: 'accessing' stamp: 'HwaJong 2/23/2014 20:15'!
model: aFloor
	model := aFloor.
	self changed: #bitizen1Name.
	self changed: #bitizen2Name.
	self changed: #bitizen3Name.
	self changed: #bitizen4Name.
	self changed: #bitizen5Name.! !

!FloorController methodsFor: 'accessing' stamp: 'HwaJong 2/25/2014 12:25'!
ownerController
	^ownerController! !

!FloorController methodsFor: 'accessing' stamp: 'HwaJong 2/25/2014 12:25'!
ownerController: aTinyTowerGameController
	ownerController := aTinyTowerGameController! !

!FloorController methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/25/2014 12:25'!
setBitizen1
	self setBitizenAt: 1! !

!FloorController methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/25/2014 12:25'!
setBitizen2
	self setBitizenAt: 2! !

!FloorController methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/25/2014 12:25'!
setBitizen3
	self setBitizenAt: 3! !

FloorController subclass: #ResidentFloorController2
	instanceVariableNames: 'bitizenListModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!ResidentFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 11:54'!
addBitizenToFloor
	|cb|
	cb := ChooseFromBuilder new.
	cb title: 'select bitizen to live here'.
	model game homelessBitizens do: [:each| 
		cb choiceString: each bitName value: 
			[model addBitizen: each.
			self changed: #bitizenListSize.
			self changed: #bitizenListElementAt:.
			ownerController
				ifNotNil: [:that| that changed: #floorListElementAt:] ] ].
	cb chooseFromValuesTitle.! !

!ResidentFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 22:01'!
bitizenIsSelected
	^self bitizenListModel hasSelection! !

!ResidentFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 22:03'!
bitizenListElementAt: anInteger 
	| b |
	b := self bitizenListModel list at: anInteger.
	^{b bitName}! !

!ResidentFloorController2 methodsFor: 'as yet unclassified ' stamp: 'HwaJong 3/1/2014 21:59'!
bitizenListIndex
	^self bitizenListModel selectionIndex! !

!ResidentFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 22:03'!
bitizenListIndex: anInteger 
	self bitizenListModel selectionIndex: anInteger.
	self changed: #bitizenListIndex.
	self changed: #bitizenIsSelected. ! !

!ResidentFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:59'!
bitizenListModel
	^bitizenListModel setDefault: #bitizenListModelDefault for: self withSetter: #bitizenListModel:! !

!ResidentFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:59'!
bitizenListModel: aTGListModel 
	bitizenListModel := aTGListModel! !

!ResidentFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:59'!
bitizenListModelDefault
	^model
		ifNil: [ TGListModel new ] 
		ifNotNil: [ TGListModel new list: model bitizenOrderedCollection ]! !

!ResidentFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 22:00'!
bitizenListSize
	^self bitizenListModel list size! !

!ResidentFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 22:01'!
canAddBitizen
	^model 
		ifNil: [ false ]
		ifNotNil: [ model bitizenOrderedCollection size < model maxPopulation ]! !

!ResidentFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 22:02'!
model: aFloor
	model := aFloor.
	self bitizenListModel: nil.
	self changed: #bitizenListSize.
	self changed: #bitizenListElementAt:.
	self changed: #canAddBitizen.! !

!ResidentFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:58'!
morph
	| q |
	q := QuickPrototyping for: self.
	^q column: 
		{q fastMultiList: #bitizen.
		q row: 
			{q button: '+' action: #addBitizenToFloor enabled: #canAddBitizen.
			q button: '-' action: #removeBitizenFromFloor enabled: #bitizenIsSelected.
			q button: 'up' action: #moveUpSelectedBitizen enabled: #bitizenIsSelected.
			q button: 'down' action: #moveDownSelectedBitizen enabled: #bitizenIsSelected.}}! !

!ResidentFloorController2 methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 11:56'!
removeBitizenFromFloor
	| b |
	b := self bitizenListModel selection.
	model removeBitizen: b.
	self model: model.
	ownerController ifNotNil: [ :that| that changed: #floorListElementAt:  ]! !

Object subclass: #ObjectManagedByTinyTowerGame
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

ObjectManagedByTinyTowerGame subclass: #Bitizen
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: 'bitName foodAbility serviceAbility recreationAbility retailAbility creativeAbility homeFloor jobFloor dreamJob'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

Bitizen class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

!Bitizen class methodsFor: 'instance creation' stamp: 'HwaJong 12/10/2012 13:33'!
bitName: aByteString dreamJobName: aByteString2 food: aSmallInteger service: aSmallInteger4 recreation: aSmallInteger5 retail: aSmallInteger6 creative: aSmallInteger7 
	^self new
		bitName: aByteString;
		foodAbility: aSmallInteger;
		serviceAbility: aSmallInteger4;
		recreationAbility: aSmallInteger5;
		retailAbility: aSmallInteger6;
		creativeAbility: aSmallInteger7;
		dreamJobName: aByteString2! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 00:28'!
abilityOfEmployedJob
	^self job meaningfulAbilityOfBitizen: self! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 2/22/2014 21:29'!
announcer
	^game announcer! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 22:23'!
beJobless
	jobFloor
		ifNotNil:  
			[jobFloor removeBitizen: self.
			self jobFloor: nil]! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
bitName
	^ bitName! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 2/22/2014 21:38'!
bitName: aString
	bitName := aString asUppercase.
	game ifNotNil: [ game announcer announce: (BitizenNameChanged new) ]
! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:46'!
checkUsingJob: aTTJob 
	(self referencesJob: aTTJob)
		ifTrue: [ TTJobInUse new job: aTTJob; signal ]! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
creativeAbility
	^ creativeAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:15'!
creativeAbility: anInteger
	creativeAbility := anInteger! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 23:44'!
dreamJob
	^ dreamJob! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:50'!
dreamJob: aTTJob
	dreamJob := aTTJob! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
foodAbility
	^ foodAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:15'!
foodAbility: anInteger
	foodAbility := anInteger! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 11:03'!
getJobNamed: aString 
	self jobFloor: (game floorJobNamed: aString).! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:07'!
gettersForEquality
	^#(bitName)! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 00:27'!
happiness
	jobFloor isNil ifTrue: [ ^1 ].
	^jobFloor job == dreamJob 
		ifTrue: [ 3 ]
		ifFalse: 
			[ self abilityOfEmployedJob < 5
				ifTrue: [1]
				ifFalse: [2] ]! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 00:12'!
hasHome
	^homeFloor notNil ! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 15:58'!
hasJob
	^jobFloor notNil ! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:23'!
homeFloor
	^ homeFloor! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:23'!
homeFloor: aFloor
	homeFloor := aFloor
! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/24/2014 01:16'!
homeFloorNumber
	^homeFloor
		ifNil: [ -1 ] ifNotNil: [ homeFloor number ]! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 2/16/2014 10:07'!
homeFoor: aResidentFloor 
	homeFloor := aResidentFloor ! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/22/2014 22:07'!
isEmployeed
	^jobFloor notNil ! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/26/2014 17:35'!
job
	^jobFloor
		ifNil: [ nil ] ifNotNil: [ jobFloor job ]! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:23'!
jobFloor
	^ jobFloor! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:23'!
jobFloor: aFloor
	jobFloor := aFloor
! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:09'!
printOn: stream

	super printOn: stream.
	stream nextPut: $(.
	stream nextPutAll: bitName.
	stream nextPut: $).! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
recreationAbility
	^ recreationAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:15'!
recreationAbility: anInteger
	recreationAbility := anInteger! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 00:25'!
referencesFloor: aFloor 
	^homeFloor == aFloor or: [ jobFloor == aFloor ]! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:18'!
referencesJob: aTTJob 
	^dreamJob == aTTJob or: [ self job == aTTJob ]! !

!Bitizen methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 00:46'!
removeFromGame
	game removeBitizen: self! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
retailAbility
	^ retailAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:15'!
retailAbility: anInteger
	retailAbility := anInteger! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:14'!
serviceAbility
	^ serviceAbility! !

!Bitizen methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:15'!
serviceAbility: anInteger
	serviceAbility := anInteger! !

ObjectManagedByTinyTowerGame subclass: #Floor
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

Floor subclass: #BitizenedFloor
	instanceVariableNames: 'bitizenArray bitizenOrderedCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!BitizenedFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 23:46'!
bitizenCount
	^self bitizenOrderedCollection count: #notNil! !

!BitizenedFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:36'!
bitizenOrderedCollection
	^bitizenOrderedCollection setDefault: #bitizenOrderedCollectionDefault for: self withSetter: #bitizenOrderedCollection:! !

!BitizenedFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:37'!
bitizenOrderedCollection: anOrderedCollection
	bitizenOrderedCollection := anOrderedCollection! !

!BitizenedFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:39'!
bitizenOrderedCollectionDefault
	^game 
		ifNil: [OrderedCollection new]
		ifNotNil: [ (game bitizens select: [ :each| each referencesFloor: self ]) asOrderedCollection ]! !

!BitizenedFloor methodsFor: 'accessing' stamp: 'HwaJong 2/23/2014 00:13'!
bitizens
	^self bitizenArray asSet! !

!BitizenedFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/28/2014 20:50'!
isBitizenful
	^self bitizenCount >= self maxPopulation! !

BitizenedFloor subclass: #CommercialFloor
	instanceVariableNames: 'job'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!CommercialFloor class methodsFor: 'instance creation' stamp: 'HwaJong 12/10/2012 17:21'!
number: aSmallInteger job: aJob 
	^self new
		number: aSmallInteger;
		job: aJob! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:35'!
addBitizen: aBitizen 

	(self bitizenOrderedCollection includes: aBitizen)
		ifFalse: 
			[self bitizenOrderedCollection add: aBitizen.
			aBitizen jobFloor: self]
	! !

!CommercialFloor methodsFor: 'accessing' stamp: 'HwaJong 3/1/2014 20:37'!
bitizenArray
	self deprecated: 'use bitizenOrderedCollection'.
	^bitizenArray setDefault: #bitizenArrayDefault for: self withSetter: #bitizenArray:! !

!CommercialFloor methodsFor: 'accessing' stamp: 'HwaJong 3/1/2014 20:38'!
bitizenArray: anArray 
	self deprecated: 'use bitizenOrderedCollection'.
	bitizenArray := anArray! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/25/2014 01:29'!
bitizenArrayAt: anInteger put: aBitizen 

	self bitizenArray at: anInteger put: aBitizen.
	aBitizen jobFloor: self! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 21:58'!
bitizenArrayDefault
	^Array new: self maxPopulation! !

!CommercialFloor methodsFor: 'as yet unclassified ' stamp: 'HwaJong 2/26/2014 13:48'!
bitizenArrayRemoveAt: anInteger 
	(self bitizenArray at: anInteger) jobFloor: nil.
	self bitizenArray at: anInteger put: nil.! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:46'!
checkUsingJob: aTTJob 
	(self referencesJob: aTTJob)
		ifTrue: [ TTJobInUse new job: aTTJob; signal ]! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 11:00'!
employBitizen: aBitizen 
	self bitizens add: aBitizen.
	aBitizen jobFloor: self.! !

!CommercialFloor methodsFor: 'literal interface' stamp: 'HwaJong 2/16/2014 10:08'!
employBitizenNamed: aString 
	self employBitizen: (game bitizenNamed: aString)! !

!CommercialFloor methodsFor: 'testing' stamp: 'HwaJong 12/10/2012 17:49'!
hasJobNamed: aByteString 
	^job jobName = aByteString ! !

!CommercialFloor methodsFor: 'testing' stamp: 'HwaJong 12/10/2012 01:30'!
isCommercialFloor
	^true! !

!CommercialFloor methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:32'!
job
	^ job! !

!CommercialFloor methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:32'!
job: aString
	job := aString
! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 17:26'!
listRowLiteral
	^{number printString. job jobName}! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 13:36'!
longerSummaryString
	^job jobName, ' (', number printString, ')'! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 01:14'!
maxPopulation
	^3! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 01:45'!
printOn: stream
	super printOn: stream.
	stream nextPut: $(.
	stream nextPutAll: job jobName.
	stream nextPut: $).! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:18'!
referencesJob: aTTJob 
	^job == aTTJob! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:20'!
removeBitizen: aBitizen
	(self bitizenOrderedCollection includes: aBitizen)
		ifTrue: 
			[self bitizenOrderedCollection remove: aBitizen.
			aBitizen jobFloor: nil ]! !

!CommercialFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 22:32'!
summaryString
	^job jobName! !

BitizenedFloor subclass: #ResidentFloor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!ResidentFloor class methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 17:15'!
number: aSmallInteger 
	^self new number: aSmallInteger! !

!ResidentFloor methodsFor: 'as yet unclassified ' stamp: 'HwaJong 3/3/2014 11:50'!
addBitizen: aBitizen 

	(self bitizenOrderedCollection includes: aBitizen)
		ifFalse: 
			[self bitizenOrderedCollection add: aBitizen.
			aBitizen homeFloor: self]
	! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:38'!
bitizenArray
	self deprecated: 'use bitizenOrderedCollection'.
	^bitizenArray setDefault: #bitizenArrayDefault for: self withSetter: #bitizenArray:! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:38'!
bitizenArray: anArray 
	self deprecated: 'use bitizenOrderedCollection'.
	bitizenArray := anArray! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 00:34'!
bitizenArrayAt: anInteger put: aBitizen

	self bitizenArray at: anInteger put: aBitizen.
	aBitizen homeFloor: self! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 00:15'!
bitizenArrayDefault
	^Array new: self maxPopulation! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 00:35'!
bitizenArrayRemoveAt: anInteger 
	(self bitizenArray at: anInteger) homeFloor: nil.
	self bitizenArray at: anInteger put: nil.! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:46'!
checkUsingJob: aTTJob 
	(self referencesJob: aTTJob)
		ifTrue: [ TTJobInUse new job: aTTJob; signal ]! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/24/2014 01:05'!
fixBitizensHomeFloor
	self bitizenArray do: [ :each| 
		each
			ifNotNil: [ each homeFloor: self ] ]! !

!ResidentFloor methodsFor: 'testing' stamp: 'HwaJong 12/10/2012 17:49'!
hasJobNamed: aByteString 
	^false! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 17:25'!
listRowLiteral
	^{number printString}! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 01:14'!
maxPopulation
	^5! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 11:08'!
moveInBitizen: aBitizen 

	self bitizens add: aBitizen.
	aBitizen homeFloor: self.! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 11:09'!
moveInBitizenNamed: aString 
	self moveInBitizen: (game bitizenNamed: aString)! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:15'!
referencesJob: aServiceJob 
	^false! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 11:55'!
removeBitizen: aBitizen 
	(self bitizenOrderedCollection includes: aBitizen)
		ifTrue: 
			[self bitizenOrderedCollection remove: aBitizen.
			aBitizen homeFloor: nil ]! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 00:26'!
removeFromGame
	self game removeFloor: self.! !

!ResidentFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:39'!
summaryString
	^'Resident  ', (self bitizenOrderedCollection count: [ :each| each notNil ]) printString, '/5'! !

!Floor methodsFor: 'testing' stamp: 'HwaJong 2/25/2014 10:26'!
isCommercialFloor
	^false! !

!Floor methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:12'!
number
	^ number! !

!Floor methodsFor: 'accessing' stamp: 'HwaJong 12/10/2012 01:12'!
number: anInteger
	number := anInteger
! !

Floor subclass: #LoungeFloor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!LoungeFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:46'!
checkUsingJob: aTTJob 
	(self referencesJob: aTTJob)
		ifTrue: [ TTJobInUse new job: aTTJob; signal ]! !

!LoungeFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 10:03'!
hasJobNamed: aString 
	^false! !

!LoungeFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:15'!
referencesJob: aTTJob 
	^false! !

!LoungeFloor methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/23/2014 23:03'!
summaryString
	^'LOUNGE'! !

!ObjectManagedByTinyTowerGame methodsFor: 'accesing' stamp: 'HwaJong 2/15/2014 20:16'!
game
	^game! !

!ObjectManagedByTinyTowerGame methodsFor: 'accesing' stamp: 'HwaJong 2/15/2014 20:16'!
game: aTinyTowerGame
	game := aTinyTowerGame! !

ObjectManagedByTinyTowerGame subclass: #TTJob
	uses: ClassCheckingHashProofTrait
	instanceVariableNames: 'jobName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

TTJob class
	uses: ClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

TTJob subclass: #CreativeJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!CreativeJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:31'!
colorName
	^#crimson! !

!CreativeJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:49'!
typeName
	^#creative! !

!CreativeJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2013 14:56'!
color
	^'crimson'! !

!CreativeJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 02:23'!
jobColor
	^Color fromHexString: 'FC6A2E'! !

!CreativeJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 00:29'!
meaningfulAbilityOfBitizen: aBitizen 
	^aBitizen creativeAbility! !

TTJob subclass: #FoodJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!FoodJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:31'!
colorName
	^#green! !

!FoodJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:49'!
typeName
	^#food! !

!FoodJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2013 15:03'!
color
	^'green'! !

!FoodJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 02:26'!
jobColor
	^Color fromHexString: '51D62E'! !

!FoodJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 00:30'!
meaningfulAbilityOfBitizen: aBitizen 
	^aBitizen foodAbility! !

TTJob subclass: #RecreationJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!RecreationJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:47'!
colorName
	^#crimson! !

!RecreationJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:49'!
typeName
	^#recreation! !

!RecreationJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2013 14:57'!
color
	^'ivory'! !

!RecreationJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 02:25'!
jobColor
	^Color fromHexString: 'EDF895'! !

!RecreationJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 00:29'!
meaningfulAbilityOfBitizen: aBitizen 
	^aBitizen recreationAbility! !

TTJob subclass: #RetailJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!RetailJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:49'!
typeName
	^#retail! !

!RetailJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/19/2013 14:58'!
color
	^'purple'! !

!RetailJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 02:24'!
jobColor
	^Color fromHexString: 'E769FD'! !

!RetailJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 00:30'!
meaningfulAbilityOfBitizen: aBitizen 
	^aBitizen retailAbility! !

TTJob subclass: #ServiceJob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!ServiceJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:50'!
typeName
	^#service! !

!ServiceJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/10/2012 13:14'!
color
	^'cyan'! !

!ServiceJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2014 02:25'!
jobColor
	^Color fromHexString: '30ADFD'! !

!ServiceJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 00:30'!
meaningfulAbilityOfBitizen: aBitizen 
	^aBitizen serviceAbility! !

!TTJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:30'!
colorNameIs: aString 
	^self colorName = aString! !

!TTJob class methodsFor: 'instance creation' stamp: 'HwaJong 10/19/2013 14:50'!
crimsonJobName: string2
	^CreativeJob new jobName: string2! !

!TTJob class methodsFor: 'instance creation' stamp: 'HwaJong 10/19/2013 14:51'!
cyanJobName: string2
	^ServiceJob new jobName: string2! !

!TTJob class methodsFor: 'instance creation' stamp: 'HwaJong 10/19/2013 15:03'!
greenJobName: string2
	^FoodJob new jobName: string2! !

!TTJob class methodsFor: 'instance creation' stamp: 'HwaJong 10/19/2013 15:05'!
ivoryJobName: string2
	^RecreationJob new jobName: string2! !

!TTJob class methodsFor: 'instance creation' stamp: 'HwaJong 10/19/2013 15:05'!
jobName: aString
	^self new jobName: aString! !

!TTJob class methodsFor: 'instance creation' stamp: 'HwaJong 10/19/2013 15:05'!
purpleJobName: string2
	^RetailJob new jobName: string2! !

!TTJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:30'!
subclassOfColorName: aString 
	^self subclasses detect: [ :each| each colorNameIs: aString ]! !

!TTJob class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:48'!
subclassOfTypeName: aString 
	^self subclasses detect: [ :each| each typeName = aString ]! !

!TTJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 22:57'!
gettersForEquality
	^#(jobName)! !

!TTJob methodsFor: 'accessing' stamp: 'HwaJong 10/19/2013 15:05'!
jobName
	^ jobName! !

!TTJob methodsFor: 'accessing' stamp: 'HwaJong 3/1/2014 18:16'!
jobName: aString
	jobName := aString asUppercase.
	game ifNotNil: [ game jobs rehash ]! !

!TTJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 23:08'!
printOn: stream

	stream nextPut: $(.
	stream nextPutAll: self class typeName.
	stream nextPut: $|.
	stream nextPutAll: jobName.
	stream nextPut: $).! !

!TTJob methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 23:09'!
removeFromGame
	game removeJob: self! !

ObjectManagedByTinyTowerGame subclass: #TTMission
	instanceVariableNames: 'name ordinalNumber requiredJobs isDone'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 13:56'!
availableString
	^self canBeDone
		ifTrue: [ 'can' ]
		ifFalse: [ 'cannot' ]! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 13:56'!
canBeDone
	| aj |
	aj := game jobsInBuilding.
	^self requiredJobs allSatisfy: [ :each| aj includes: each ] ! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:46'!
checkUsingJob: aTTJob 
	(self referencesJob: aTTJob)
		ifTrue: [ TTJobInUse new job: aTTJob; signal ]! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 17:18'!
doneString
	^self isDone
		ifTrue: [ 'done' ]
		ifFalse: [ 'not done' ]! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 17:18'!
isDone
	^isDone setDefault: #isDoneDefault for: self withSetter: #isDone:! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 17:21'!
isDone: aBoolean 
	isDone := aBoolean! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 17:18'!
isDoneDefault
	^false! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 23:59'!
name
	^name setDefault: #nameDefault for: self withSetter: #name:! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 01:16'!
name: aString 
	name := aString asUppercase! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 00:00'!
nameDefault
	^'no name'! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 01:19'!
ordinalNumber
	^ ordinalNumber! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 00:47'!
ordinalNumber: anInteger 
	ordinalNumber := anInteger ! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 01:18'!
referencesJob: aTTJob 
	^self requiredJobs identityIncludes: aTTJob! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 23:58'!
requiredJobs
	^ requiredJobs setDefault: #requiredJobsDefault for: self withSetter: #requiredJobs:! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 01:02'!
requiredJobs: aCollection 
	requiredJobs := aCollection ! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 23:58'!
requiredJobsDefault
	^OrderedCollection new! !

!TTMission methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 17:30'!
toggleDone
	self isDone: self isDone not! !

Object subclass: #TTMissionProxy
	instanceVariableNames: 'ordinalNumber name requiredJobNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTMissionProxy class methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 00:43'!
ordinalNumber: anInteger name: aString requiredJobNames: aCollection 
	^self new
		ordinalNumber: anInteger;
		name: aString;
		requiredJobNames: aCollection ! !

!TTMissionProxy methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 00:43'!
name: aString 
	name := aString ! !

!TTMissionProxy methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 00:43'!
ordinalNumber: anInteger 
	ordinalNumber := anInteger ! !

!TTMissionProxy methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 00:43'!
requiredJobNames: aCollection 
	requiredJobNames := aCollection ! !

!TTMissionProxy methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 01:00'!
valueWithGame: aTinyTowerGame 
	| realObject |
	realObject := TTMission new.
	realObject name: name.
	realObject ordinalNumber: ordinalNumber.
	realObject requiredJobs: (requiredJobNames collect: 
		[:each| 
			[aTinyTowerGame jobNamed: each] on: TTNoJobError
			do:
				[:exp| exp addJobAndRetry ] ]).
	^realObject! !

Object subclass: #TinyTowerGame
	instanceVariableNames: 'floors bitizens jobs announcer missions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TinyTowerGame class methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/22/2013 16:06'!
workspace1
| tt |
tt := TinyTowerGame new.
tt openBitizenListMorph.
tt openCommercialFloorListMorph.
tt bitizenFromUser.! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/15/2014 19:53'!
addBitizen: aBitizen

	self bitizens add: aBitizen.
	aBitizen game: self.
	^aBitizen! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/15/2014 19:51'!
addBitizen: aBitizen atHome: aFloor

	self bitizens add: aBitizen.
	aFloor addResidentBitizen: aBitizen.
	aBitizen game: self.
	^aBitizen! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/16/2014 12:07'!
addBitizenName: string1 dreamJobName: string2 food: integer2 service: integer3 recreation: integer4 retail: integer5 creative: integer6

	| b d |
	b := Bitizen new bitName: string1.
	d := self jobNamed: string2.
	b foodAbility: integer2.
	b serviceAbility: integer3.
	b recreationAbility: integer4.
	b retailAbility: integer5.
	b creativeAbility: integer6.
	b dreamJob: d.
	^self addBitizen: b.! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/16/2014 09:58'!
addBitizenName: string1 dreamJobName: string2 homeFoorNumber: integer1 food: integer2 service: integer3 recreation: integer4 retail: integer5 creative: integer6

	| b |
	b := Bitizen new bitName: string1.
	b foodAbility: integer2.
	b serviceAbility: integer3.
	b recreationAbility: integer4.
	b retailAbility: integer5.
	b creativeAbility: integer6.
	b dreamJob: (self jobNamed: string2).
	b homeFoorNumber: integer1.
	^self addBitizen: b.! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/16/2014 12:03'!
addBitizenName: string1 dreamJobName: string2 homeFoorNumber: integer1 food: integer2 service: integer3 recreation: integer4 retail: integer5 creative: integer6 employedAt: string3


	| b  h w |
	b := Bitizen new bitName: string1.
	h := self floorAt: integer1.
	w := self floorJobNamed: string3.
	b foodAbility: integer2.
	b serviceAbility: integer3.
	b recreationAbility: integer4.
	b retailAbility: integer5.
	b creativeAbility: integer6.
	b dreamJob: (self jobNamed: string2).
	h moveInBitizen: b.
	w employBitizen: b.
	^self addBitizen: b.! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/15/2014 22:24'!
addBitizenName: string1 dreamType: symbol1 dreamJobName: string2 food: integer2 service: integer3 recreation: integer4 retail: integer5 creative: integer6

	| b |
	b := Bitizen new bitName: string1.
	b foodAbility: integer2.
	b serviceAbility: integer3.
	b recreationAbility: integer4.
	b retailAbility: integer5.
	b creativeAbility: integer6.
	b dreamJob: (self addJobNamed: string2 type: symbol1).
	^self addBitizen: b.! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/16/2014 09:58'!
addBitizenName: string1 dreamType: symbol1 dreamJobName: string2 homeFoorNumber: integer1 food: integer2 service: integer3 recreation: integer4 retail: integer5 creative: integer6

	| b |
	b := Bitizen new bitName: string1.
	b foodAbility: integer2.
	b serviceAbility: integer3.
	b recreationAbility: integer4.
	b retailAbility: integer5.
	b creativeAbility: integer6.
	b dreamJob: (self addJobNamed: string2 type: symbol1).
	b homeFloor: (self floorAt: integer1).
	^self addBitizen: b.! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 3/1/2014 01:00'!
addCommercialFloorJobNamed: aString

	[self addFloor: (CommercialFloor new job: (self jobNamed: aString))] on: TTNoJobError
		do: [ :exp| 
			exp addJobAndRetry]! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 2/15/2014 20:26'!
addFloor: aFloor
	self floors add: aFloor.
	aFloor number: (self floors indexOf: aFloor).
	aFloor game: self.! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 2/15/2014 22:57'!
addJob: aTTJob 
	self jobs add: aTTJob.
	aTTJob game: self! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 3/1/2014 09:09'!
addJobNamed: aString 
	| cb |
	cb := ChooseFromBuilder new.
	cb title: 'type of job ', aString asUppercase.
	{ FoodJob. ServiceJob. RecreationJob. RetailJob. CreativeJob } do: 
		[:each| cb choiceString: each typeName value: 
			[ |job|
			job := each new jobName: aString.
			self addJob: job.
			^job ] ].
	cb chooseFromValuesTitle.! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 2/15/2014 22:54'!
addJobNamed: aString type: aString2 
	^self addJob: ((TTJob subclassOfTypeName: aString2) new jobName: aString)! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 2/15/2014 19:55'!
addLoungeFloor
	self addFloor: (LoungeFloor new)! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/1/2014 01:08'!
addMission: aTTMission 
	self missions add: aTTMission.
	aTTMission game: self.! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/1/2014 17:56'!
addMissionWithProxy: aTTMissionProxy 
	|aTTMission|
	aTTMission := aTTMissionProxy valueWithGame: self.
	(aTTMission requiredJobs allSatisfy: [ :each| each isKindOf: TTJob ])
		ifTrue: [ self addMission: aTTMission ]! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 2/16/2014 00:23'!
addReisdentalFloor
	self addFloor: (ResidentFloor new)! !

!TinyTowerGame methodsFor: 'announcer' stamp: 'HwaJong 2/22/2014 21:08'!
announcer
	^ announcer setDefault: #announcerDefault for: self withSetter: #announcer:! !

!TinyTowerGame methodsFor: 'announcer' stamp: 'HwaJong 2/22/2014 21:15'!
announcer: anAnnouncer 
	announcer ifNotNil: [ announcer unsubscribe: self ].
	announcer := anAnnouncer! !

!TinyTowerGame methodsFor: 'announcer' stamp: 'HwaJong 2/22/2014 21:15'!
announcerDefault
	^Announcer new
		on: BitizenNameChanged do: [ :ann| self bitizens rehash ];
		yourself! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/22/2014 01:29'!
bitizenFromUser

	|bitiArray|
	bitiArray := bitizens asArray.
	^bitiArray at: (UIManager default chooseFrom: (bitiArray collect: #bitName))
	! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/16/2014 01:34'!
bitizenNamed: aString 
	|up|
	up := aString asUppercase.
	^self bitizens detect: [ :each| each bitName = up ]! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:40'!
bitizens
	^bitizens setDefault: #bitizensDefault for: self withSetter: #bitizens:! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:40'!
bitizens: aCollection
	bitizens := aCollection! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:40'!
bitizensDefault
	^Set new! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/26/2014 17:46'!
bitizensWhoCanGetTheirDreamJob
	^(self bitizens select: [ :each| each job ~= each dreamJob ]) select: [ :each| self jobsInBuilding includes: each dreamJob ]. ! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 2/25/2014 10:28'!
commercialFloors
	^self floors select: [ :each| each isCommercialFloor ]! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 2/28/2014 20:51'!
commercialFloorsNeedingBitizen
	^self commercialFloors select: [ :each| each isBitizenful not ]! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 12/10/2012 17:47'!
floorAt: aSmallInteger 
	^floors detect: [:each| each number = aSmallInteger]! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 2/16/2014 10:04'!
floorJobNamed: aByteString 
	| up |
	up := aByteString asUppercase.
	^floors detect: [:each| each hasJobNamed: up] ! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:54'!
floors
	^floors setDefault: #floorsDefault for: self withSetter:  #floors:  afterSetOperation: #addLoungeFloor! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:41'!
floors: aCollection
	floors := aCollection! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:54'!
floorsDefault
	^OrderedCollection new! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 3/1/2014 17:52'!
hasJobNamed: aString 
	^(self nilOrJobNamed: aString) notNil! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/23/2014 00:25'!
homelessBitizens
	^self bitizens select: [ :each| each hasHome not ]! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 2/16/2014 01:08'!
jobNamed: aString 
	|upperString|
	upperString := aString asUppercase.
	^self jobs detect: [ :each| each jobName = upperString ] ifNone: [ TTNoJobError new game: self; jobName: aString; signal ]! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:47'!
jobs

	^jobs setDefault: #jobsDefault for: self withSetter: #jobs:! !

!TinyTowerGame methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 19:46'!
jobs: anObject
		
	jobs := anObject! !

!TinyTowerGame methodsFor: 'defaults' stamp: 'HwaJong 2/15/2014 19:47'!
jobsDefault

	^Set new! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 2/26/2014 17:37'!
jobsInBuilding
	^self commercialFloors collect: #job! !

!TinyTowerGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/26/2014 16:06'!
leastElevatorPpmRequired
	|pps max|
	pps := { 42. 16. 12. 8. 4 }.
	max := 193.
	^pps allButFirst detect: [ :p|
		(self floors size/max) > (p/pps first)
			 ]ifNone: [pps last]! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/23/2014 22:12'!
makeAllBitizensHomeless
	self bitizens do: [ :each| each homeFloor: nil ]! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/23/2014 22:20'!
makeAllBitizensJobless
	self bitizens do: [ :each| each beJobless ]! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/1/2014 00:35'!
missions
	^missions setDefault: #missionsDefault for: self withSetter: #missions:! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/1/2014 00:37'!
missions: aCollection 
	missions := aCollection! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/1/2014 00:37'!
missionsDefault
	^SortedCollection sortBlock: (UnarySortDescriptor ascendingBy: #ordinalNumber)! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/2/2014 13:54'!
missionsNotDoneYet
	^self missions select: [ :each| each isDone not ]! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/2/2014 13:57'!
missionsNotDoneYetButCanBeDone
	^self missionsNotDoneYet select: [:each| each canBeDone]. ! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 3/1/2014 17:52'!
nilOrJobNamed: aString 
	|upperString|
	upperString := aString asUppercase.
	^self jobs detect: [ :each| each jobName = upperString ] ifNone: [ nil ]! !

!TinyTowerGame methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/24/2014 17:56'!
overcrowdedDreamJobAssociations
	| dreamJobGroup |
	dreamJobGroup := Dictionary new.
	self bitizens do: [:each| dreamJobGroup at: each dreamJob add: each ].
	^dreamJobGroup associations select: [:each| each value size > 3 ]! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/23/2014 00:54'!
removeBitizen: aBitizen 
	self bitizens remove: aBitizen.
	aBitizen homeFloor
		ifNotNil: [:that| that removeBitizen: aBitizen].
	aBitizen jobFloor removeBitizen: aBitizen.! !

!TinyTowerGame methodsFor: 'floor' stamp: 'HwaJong 2/16/2014 00:27'!
removeFloor: aResidentFloor 
	self floors remove: aResidentFloor.
	aResidentFloor game: nil! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 3/1/2014 09:49'!
removeJob: aTTJob 
	
	self floors do: [ :each| (each checkUsingJob: aTTJob) ].
	self bitizens do: [ :each| (each checkUsingJob: aTTJob) ].
	self missions do: [ :each| (each checkUsingJob: aTTJob) ].
	
	self jobs remove: aTTJob.
	aTTJob game: nil! !

!TinyTowerGame methodsFor: 'mission' stamp: 'HwaJong 3/1/2014 17:57'!
removeMission: aTTMission 
	self missions remove: aTTMission.
	aTTMission game: nil.! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 3/2/2014 01:17'!
thoseReferencingJob: aJob 
	|those work|
	those := Set new.
	work := [  :each| (each referencesJob: aJob) ifTrue: [ those add: each ]  ].
	self floors do: work.
	self bitizens do: work.
	self missions do: work.
	^those! !

!TinyTowerGame methodsFor: 'bitizen' stamp: 'HwaJong 2/22/2014 22:07'!
unemployeedBitizens
	^self bitizens select: [ :each| each isEmployeed not ]! !

!TinyTowerGame methodsFor: 'job' stamp: 'HwaJong 3/1/2014 17:15'!
unflooredJobs
	^self jobs difference: (self jobsInBuilding)! !

Object subclass: #TinyTowerGameController
	instanceVariableNames: 'model bitizenListModel bitizenNameFilterString sortBitizenDropListModel floorListModel residentFloorController selectedBititzenMorph commercialFloorController jobListModel floorDetailTabMorph missionListModel requiredJobListModel missionNameFilterString issueListModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TinyTowerGameController commentStamp: '' prior: 0!
A TinyTowerGame is xxxxxxxxx.

Instance Variables
	bitizens:		<Object>
	floors:		<Object>

bitizens
	- xxxxx

floors
	- xxxxx
!

!TinyTowerGameController class methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 19:35'!
workspace1
| tt |
tt := TinyTowerGame new.
tt openBitizenListMorph.
tt openCommercialFloorListMorph.
tt bitizenFromUser.! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 2/23/2014 23:53'!
addBitizen
	| dw |
	dw := BitizenDialogWindow new.
	dw model: (Bitizen new game: model).
	UIManager default openModal: dw.
	^dw cancelled
		ifTrue: 
			[nil]
		ifFalse: 
			[model addBitizen: (dw model).
			self bitizenListModel: nil.
			self changed: #bitizenListSize.
			self changed: #bitizenListElementAt:.
			dw model]! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 3/3/2014 13:38'!
addCommercialFloor
	| cb |
	cb := ChooseFromBuilder new.
	cb title: 'select job of commerical floor', (model floors size + 1) printString.
	model unflooredJobs do: 
		[:each| 
		cb choiceString: each jobName value: 
			[model addFloor: (CommercialFloor new job: each).
			self updateFloorListItemAndDetailAfterAddingFloor ] ].
	cb chooseFromValuesTitle.
	! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 2/28/2014 00:14'!
addFloor
	| menu |
	menu := MenuMorph new.
	menu add: 'commercial' target: self action: #addCommercialFloor.
	menu add: 'resident' target: self action: #addResidentFloor.
	menu popUpInWorld: self currentWorld.! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 3/1/2014 09:09'!
addJob
	| jobName |
	jobName := (UIManager default request: 'name of new job') asUppercase.
	jobName
		isEmptyOrNil
			ifFalse: [
				| job | 
				job := model addJobNamed: jobName.
				self jobListModel: nil.
				self jobListModel selection: job.
				self changed: #jobListSize.
				self changed: #jobListElementAt:.
				self changed: #jobListIndex ]! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 3/2/2014 00:29'!
addMission
	| ms |
	ms := TTMission new.
	self missionListModel list isEmpty
		ifTrue: [ ms ordinalNumber: 10 ]
		ifFalse: [ ms ordinalNumber: self missionListModel list last ordinalNumber + 10 ].
	model addMission: ms.
	self missionListModel: nil.
	self missionListModel selection: ms.
	self changed: #missionListSize.
	self changed: #missionListElementAt:.
	self changed: #missionListIndex.
	self changed: #ordinalNumberString.
	self changed: #missionName.
	self requiredJobListModel: nil.
	self changed: #requiredJobsForSelectedMissionListSize.
	self changed: #requiredJobsForSelectedMissionListElementAt:.! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 3/2/2014 00:13'!
addRequiredJobToMission
	| cb |
	cb := ChooseFromBuilder new.
	cb title: 'add to required job'.
	model jobs do:
		[:each| cb choiceString: each jobName value: 
			[self missionListModel selection requiredJobs add: each.
			self changed: #requiredJobsForSelectedMissionListSize.
			self changed: #requiredJobsForSelectedMissionListElementAt:.
			self changed: #missionListElementAt:  ] ].
	cb chooseFromValuesTitle.
	 ! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 3/3/2014 13:38'!
addResidentFloor
	model addReisdentalFloor.
	self updateFloorListItemAndDetailAfterAddingFloor.! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:32'!
arrowKey: aCharacter from: aPluggableMultiColumnListMorph 
	aPluggableMultiColumnListMorph getListElementSelector = #bitizenListElementAt:
		ifTrue: [ self bitizenListModel selection inspect ] ! !

!TinyTowerGameController methodsFor: 'testing' stamp: 'HwaJong 2/22/2014 02:22'!
bitizenIsSelected
	^self bitizenListModel hasSelection ! !

!TinyTowerGameController methodsFor: 'list element' stamp: 'HwaJong 2/25/2014 10:30'!
bitizenListElementAt: anInteger 
	| bit |
	bit := self bitizenListModel list at: anInteger.
	^{
		bit bitName. 
		bit dreamJob ifNil: [ 'nil' ] ifNotNil: [:that| 'dream ', that jobName ]. 
		bit foodAbility printString. 
		bit serviceAbility printString. 
		bit recreationAbility printString. bit retailAbility printString. 
		bit creativeAbility printString. 
		bit jobFloor ifNil: [ 'nil' ] ifNotNil: [:that| 'job ', that number printString ].
		bit homeFloor ifNil: [ 'nil' ] ifNotNil: [:that| 'home ', that number printString ] 
	}! !

!TinyTowerGameController methodsFor: 'get list index' stamp: 'HwaJong 2/22/2014 01:44'!
bitizenListIndex
	^self bitizenListModel selectionIndex! !

!TinyTowerGameController methodsFor: 'set list index' stamp: 'HwaJong 2/28/2014 01:30'!
bitizenListIndex: anInteger 
	self bitizenListModel selectionIndex: anInteger.
	self selectedBititzenMorph model: (self bitizenListModel selection).
	self changed: #bitizenListIndex.
	self changed: #bitizenIsSelected.
	self changed: #bitizenName.
	self changed: #jobFloorString.
	self changed: #homeFloorString.! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 2/22/2014 01:44'!
bitizenListModel
	^bitizenListModel setDefault: #bitizenListModelDefault for: self withSetter: #bitizenListModel:! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 2/22/2014 01:45'!
bitizenListModel: aTGListModel 
	bitizenListModel := aTGListModel! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 2/22/2014 03:43'!
bitizenListModelDefault
	|upper|
	upper := self bitizenNameFilterString asUppercase.
	^TGListModel new list: 
		((model bitizens select: [:each| upper isEmpty or: [(each bitName findString: upper) > 0] ]) asSortedCollection: (self sortBitizenDropListModel selection))! !

!TinyTowerGameController methodsFor: 'list size' stamp: 'HwaJong 2/22/2014 01:46'!
bitizenListSize
	^self bitizenListModel list size! !

!TinyTowerGameController methodsFor: 'strings' stamp: 'HwaJong 2/22/2014 04:08'!
bitizenName
	^self bitizenListModel selection bitName ! !

!TinyTowerGameController methodsFor: 'strings' stamp: 'HwaJong 2/25/2014 01:13'!
bitizenName: aString
	"to avoid error"! !

!TinyTowerGameController methodsFor: 'strings' stamp: 'HwaJong 2/22/2014 01:48'!
bitizenNameFilterString
	^bitizenNameFilterString setDefault: #bitizenNameFilterStringDefault for: self withSetter: #bitizenNameFilterString:! !

!TinyTowerGameController methodsFor: 'strings' stamp: 'HwaJong 2/22/2014 01:52'!
bitizenNameFilterString: aString 
	bitizenNameFilterString := aString.
	self bitizenListModel: nil.
	self changed: #bitizenNameFilterString.
	self changed: #bitizenListSize.
	self changed: #bitizenListElementAt:! !

!TinyTowerGameController methodsFor: 'strings' stamp: 'HwaJong 2/22/2014 01:49'!
bitizenNameFilterStringDefault
	^String new! !

!TinyTowerGameController methodsFor: 'subs' stamp: 'HwaJong 2/25/2014 01:23'!
commercialFloorController
	^commercialFloorController setDefault: #commercialFloorControllerDefault for: self withSetter: #commercialFloorController:! !

!TinyTowerGameController methodsFor: 'subs' stamp: 'HwaJong 2/25/2014 01:24'!
commercialFloorController: aCommercialFloorController 
	commercialFloorController := aCommercialFloorController! !

!TinyTowerGameController methodsFor: 'subs' stamp: 'HwaJong 3/1/2014 20:49'!
commercialFloorControllerDefault
	^CommercialFloorController2 new ownerController: self! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 3/1/2014 15:52'!
fireSelectedBitizenFromJob
	self bitizenListModel selection beJobless.
	self changed: #bitizenListElementAt:.
	self changed: #jobFloorString.! !

!TinyTowerGameController methodsFor: 'testing' stamp: 'HwaJong 2/22/2014 21:57'!
floorIsSelected
	^self floorListModel hasSelection ! !

!TinyTowerGameController methodsFor: 'list element' stamp: 'HwaJong 2/23/2014 22:29'!
floorListElementAt: anInteger 
	| fl |
	fl := self floorListModel list at: anInteger.
	^{fl number printString. fl summaryString}! !

!TinyTowerGameController methodsFor: 'get list index' stamp: 'HwaJong 2/22/2014 21:40'!
floorListIndex
	^self floorListModel selectionIndex! !

!TinyTowerGameController methodsFor: 'set list index' stamp: 'HwaJong 3/2/2014 13:08'!
floorListIndex: anInteger 
	self floorListModel selectionIndex: anInteger.
	self changed: #floorListIndex.

	self updateFloorController.! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 2/22/2014 21:41'!
floorListModel
	^floorListModel setDefault: #floorListModelDefault for: self withSetter: #floorListModel:! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 2/22/2014 21:41'!
floorListModel: aTGListModel 
	floorListModel := aTGListModel! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 2/22/2014 21:47'!
floorListModelDefault
	^TGListModel new list: model floors reverse! !

!TinyTowerGameController methodsFor: 'list size' stamp: 'HwaJong 2/22/2014 21:41'!
floorListSize
	^self floorListModel list size ! !

!TinyTowerGameController methodsFor: 'strings' stamp: 'HwaJong 2/28/2014 01:30'!
homeFloorString
	^self bitizenListModel
		ifHasSelection: [:bz| 
			bz homeFloor
				ifNil: [ '---' ]
				ifNotNil: [:that| that number printString ] 
			] 
		ifDoesNotHaveSelection: [ '---' ].! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 3/1/2014 01:15'!
inspectMission
	^self missionListModel selection inspect! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 2/22/2014 02:23'!
inspectSelectedBitizen
	self bitizenListModel selection inspect! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 2/22/2014 21:58'!
inspectSelectedFloor
	self floorListModel selection inspect! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 13:36'!
issueListElementAt: anInteger 
	^{self issueListModel list at: anInteger}! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 13:21'!
issueListIndex
	^self issueListModel selectionIndex! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 13:37'!
issueListIndex: anInteger 
	self issueListModel selectionIndex: anInteger.! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 13:21'!
issueListModel
	^issueListModel setDefault: #issueListModelDefault for: self withSetter: #issueListModel:! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 13:22'!
issueListModel: aTGListModel 
	issueListModel := aTGListModel! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 14:40'!
issueListModelDefault
	^TGListModel new list: 
		(Array streamContents: 
			[:stream|
				model bitizensWhoCanGetTheirDreamJob do: [ :each| stream nextPut: each bitName, ' can get dream job!!!!' ].
				model commercialFloorsNeedingBitizen do: [ :each| stream nextPut: each longerSummaryString, ' needs bitizen.' ].
				model overcrowdedDreamJobAssociations do: [ :each| stream nextPut: 'overcrowded dream job: ', each printString ].
				model unemployeedBitizens do: [ :each| stream nextPut: 'unemployeed bitizen ', each bitName ].
				model missionsNotDoneYetButCanBeDone do: [ :each| stream nextPut: 'mission', each name, ' can be done.' ].
				stream nextPut: 'elevator ppm should be at least ', model leastElevatorPpmRequired printString.
			])! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 13:22'!
issueListSize
	^self issueListModel list size! !

!TinyTowerGameController methodsFor: 'strings' stamp: 'HwaJong 2/28/2014 01:29'!
jobFloorString

	^self bitizenListModel
		ifHasSelection: [:bz| 
			bz jobFloor
				ifNil: [ '---' ]
				ifNotNil: [:that| that number printString, ' ', that job jobName ] 
			] 
		ifDoesNotHaveSelection: [ '---' ].! !

!TinyTowerGameController methodsFor: 'testing' stamp: 'HwaJong 3/1/2014 09:10'!
jobIsSelected
	^self jobListModel hasSelection! !

!TinyTowerGameController methodsFor: 'list element' stamp: 'HwaJong 2/27/2014 16:18'!
jobListElementAt: anInteger 
	| j |
	j := self jobListModel list at: anInteger.
	^{	Text string: j jobName attribute: (TextColor new color: j jobColor). j class typeName }! !

!TinyTowerGameController methodsFor: 'get list index' stamp: 'HwaJong 2/27/2014 16:04'!
jobListIndex
	^self jobListModel selectionIndex! !

!TinyTowerGameController methodsFor: 'set list index' stamp: 'HwaJong 3/1/2014 09:11'!
jobListIndex: anInteger 
	self jobListModel selectionIndex: anInteger.
	self changed: #jobListIndex.
	self changed: #jobIsSelected.! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 2/27/2014 16:05'!
jobListModel
	^jobListModel setDefault: #jobListModelDefault for: self withSetter: #jobListModel:! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 2/27/2014 16:05'!
jobListModel: aTGListModel 
	jobListModel := aTGListModel! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 2/27/2014 16:15'!
jobListModelDefault
	^TGListModel new list: (model jobs asSortedCollection: (UnarySortDescriptor ascendingBy: #jobName))! !

!TinyTowerGameController methodsFor: 'list size' stamp: 'HwaJong 2/27/2014 16:06'!
jobListSize
	^self jobListModel list size! !

!TinyTowerGameController methodsFor: 'testing' stamp: 'HwaJong 3/1/2014 01:15'!
missionIsSelected
	^self missionListModel hasSelection! !

!TinyTowerGameController methodsFor: 'list element' stamp: 'HwaJong 3/1/2014 17:17'!
missionListElementAt: anInteger 
	| m |
	m := self missionListModel list at: anInteger.
	^{m ordinalNumber printString. m name. m availableString. m doneString }! !

!TinyTowerGameController methodsFor: 'get list index' stamp: 'HwaJong 3/1/2014 01:10'!
missionListIndex
	^self missionListModel selectionIndex! !

!TinyTowerGameController methodsFor: 'set list index' stamp: 'HwaJong 3/2/2014 00:03'!
missionListIndex: anInteger 
	self missionListModel selectionIndex: anInteger.
	self changed: #missionListIndex.
	self changed: #missionIsSelected.
	self changed: #selectedMissionIsDone.
	self changed: #missionName.
	
	self requiredJobListModel: nil.
	self changed: #requiredJobsForSelectedMissionListSize.
	self changed: #requiredJobsForSelectedMissionListElementAt:.
	self changed: #ordinalNumberString.
	self changed: #requiredJobIsSelected.! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 3/1/2014 01:10'!
missionListModel
	^missionListModel setDefault: #missionListModelDefault for: self withSetter:  #missionListModel:! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 3/1/2014 01:11'!
missionListModel: aTGListModel 
	missionListModel := aTGListModel! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 3/2/2014 01:29'!
missionListModelDefault
	|upper|
	upper := self missionNameFilterString asUppercase.
	^TGListModel new list: 
		( (model missions select: [:each| upper isEmpty or: [(each name findString: upper) > 0] ]) asSortedCollection: (UnarySortDescriptor ascendingBy: #ordinalNumber) )! !

!TinyTowerGameController methodsFor: 'list size' stamp: 'HwaJong 3/1/2014 01:11'!
missionListSize
	^self missionListModel list size! !

!TinyTowerGameController methodsFor: 'strings' stamp: 'HwaJong 3/2/2014 00:02'!
missionName
	^self missionListModel
		ifHasSelection: [:m| m name ]
		ifDoesNotHaveSelection:  [ '----' ]! !

!TinyTowerGameController methodsFor: 'strings' stamp: 'HwaJong 3/2/2014 00:04'!
missionName: aString
	self missionListModel
		ifHasSelection: 
			[:m| m name: aString.
			self changed: #missionName.
			self changed: #missionListElementAt:]! !

!TinyTowerGameController methodsFor: 'strings' stamp: 'HwaJong 3/2/2014 01:20'!
missionNameFilterString
	^missionNameFilterString setDefault: #missionNameFilterStringDefault for: self withSetter: #missionNameFilterString:! !

!TinyTowerGameController methodsFor: 'strings' stamp: 'HwaJong 3/2/2014 01:23'!
missionNameFilterString: aString
	missionNameFilterString := aString.
	self missionListModel: nil.
	self changed: #missionNameFilterString.
	self changed: #missionListSize.
	self changed: #missionListElementAt:.! !

!TinyTowerGameController methodsFor: 'strings' stamp: 'HwaJong 3/2/2014 01:21'!
missionNameFilterStringDefault
	^''! !

!TinyTowerGameController methodsFor: 'accessing' stamp: 'HwaJong 2/15/2014 20:48'!
model: aTinyTowerGame
	model := aTinyTowerGame! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 13:21'!
open
	| q tabs window |
	q := QuickPrototyping for: self.
	
	tabs := UITheme builder newTabGroup: 
		{
			'job' asMorph -> (q column: 
				{q fastMultiList: #job.
				q row: 
					{q button: '+' action: #addJob. 
					q button: '-' action: #removeSelectedJob.
					q button: 'rename' action: #renameJobName}}).
			'floor' asMorph -> (q splitLeft: (q column: 
				{q fastMultiList: #floor.
				q row: 
					{q button: 'inspect' action: #inspectSelectedFloor enabled: #floorIsSelected.
					q button: '+' action: #addFloor}})
					 splitRight: 
						([floorDetailTabMorph := UITheme builder newTabGroup: 
							{'Commercial' asMorph -> self commercialFloorController morph.
							'Resident' asMorph -> self residentFloorController morph }.
						floorDetailTabMorph tabSelectorMorph delete.
						floorDetailTabMorph] value) ).
			'bitizen' asMorph -> 
				(q splitLeft: 
					(q column: 
						{
							(q text: #bitizenNameFilterString) autoAccept: true. 
							q fastMultiList: #bitizen.
							q row: {q button: '+' action: #addBitizen. q dropList: #sortBitizen}.
						})
				splitRight:
					(q column: 
						{self selectedBititzenMorph 
							beSpaceFilling.
						(q 
							groupedRow: {q staticLabel: 'job'. q buttonGetLabel: #jobFloorString action: #setOrClearJobOfSelectedBitizen enabled: #bitizenIsSelected})
							beHorizontalFillingWithHeight: 30.
						q title: 'home' label: #homeFloorString.
						q button: 'inspect' action: #inspectSelectedBitizen enabled: #bitizenIsSelected})).
			'missions' asMorph -> (q 
				splitLeft: (q column: 
					{(q text: #missionNameFilterString) autoAccept: true.
					q fastMultiList: #mission. 
					q row: 
						{q button: 'i' action: #inspectMission enabled: #missionIsSelected.
						q button: 'refresh' action: #refreshMissionList.
						q button: 'reorder' action: #reorderMissions.
						q button: '+' action: #addMission } })
				splitRight: (q column: 
					{q title: 'orinal number' text: #ordinalNumberString width: 80.
					q title: 'name' text: #missionName.
					q checkbox: 'done' accessor: #selectedMissionIsDone enabled: #missionIsSelected.
					q fastMultiList: #requiredJobsForSelectedMission.
					q row: 
						{q button: '+' action: #addRequiredJobToMission enabled: #missionIsSelected.
						q button: '-' action: #removeRequiredJob enabled: #requiredJobIsSelected.} } ) ).
			'issue' asMorph -> (q column: {(q fastMultiList: #issue). q button: 'refresh' action: #refreshIssueList })
		}.
	window := tabs openInWindow.
	window setLabel: 'Tiny Tower Rocks!!'.
	window extent:  (463.0@398.0)
! !

!TinyTowerGameController methodsFor: 'strings' stamp: 'HwaJong 3/1/2014 23:11'!
ordinalNumberString
	^self missionListModel
		ifHasSelection: [:mission| mission ordinalNumber printString ] 
		ifDoesNotHaveSelection: [ '--' ]! !

!TinyTowerGameController methodsFor: 'strings' stamp: 'HwaJong 3/1/2014 23:48'!
ordinalNumberString: aString
	self missionListModel
		ifHasSelection: 
			[:mission| mission ordinalNumber: aString asNumber.
			self changed: #ordinalNumberString.
			self changed: #missionListElementAt: ] ! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/2/2014 13:33'!
refreshIssueList
	self issueListModel: nil.
	self changed: #issueListSize.
	self changed: #issueListElementAt:.! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 3/1/2014 01:30'!
refreshMissionList
	self missionListModel: nil.
	self changed: #missionListSize.
	self changed: #missionListElementAt: ! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 3/1/2014 10:13'!
removeSelectedJob
	model removeJob: self jobListModel selection.
	self jobListModel: nil.
	self changed: #jobListSize.
	self changed: #jobListElementAt:.! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 3/1/2014 18:17'!
renameJobName
	| job newJobName|
	job := self jobListModel selection.
	newJobName := UIManager default request: 'job name' initialAnswer: job jobName.
	newJobName isEmptyOrNil
		ifFalse: 
			[job jobName: newJobName.
			self changed: #jobListElementAt: ]! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 3/1/2014 17:44'!
reorderMissions
	self missionListModel list keysAndValuesDo: 
		[ :index :mission |
		mission ordinalNumber: index * 10].
	self changed: #missionListElementAt: ! !

!TinyTowerGameController methodsFor: 'testing' stamp: 'HwaJong 3/1/2014 23:41'!
requiredJobIsSelected
	^self requiredJobListModel hasSelection  ! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 3/1/2014 23:12'!
requiredJobListModel
	^requiredJobListModel setDefault: #requiredJobListModelDefault for: self withSetter: #requiredJobListModel:! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 3/1/2014 23:17'!
requiredJobListModel: aTGListModel 
	requiredJobListModel := aTGListModel! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 3/1/2014 23:17'!
requiredJobListModelDefault
	^self missionListModel 
		ifHasSelection: [:selM| TGListModel new list: selM requiredJobs ]
		ifDoesNotHaveSelection: [ TGListModel new ]! !

!TinyTowerGameController methodsFor: 'list element' stamp: 'HwaJong 3/1/2014 23:19'!
requiredJobsForSelectedMissionListElementAt: anInteger 
	| j |
	j := self requiredJobListModel list at: anInteger.
	^{j jobName}! !

!TinyTowerGameController methodsFor: 'get list index' stamp: 'HwaJong 3/1/2014 23:12'!
requiredJobsForSelectedMissionListIndex
	^self requiredJobListModel selectionIndex! !

!TinyTowerGameController methodsFor: 'set list index' stamp: 'HwaJong 3/1/2014 23:43'!
requiredJobsForSelectedMissionListIndex: anInteger 
	self requiredJobListModel selectionIndex: anInteger.
	self changed: #requiredJobsForSelectedMissionListIndex.
	self changed: #requiredJobIsSelected.! !

!TinyTowerGameController methodsFor: 'list size' stamp: 'HwaJong 3/1/2014 23:18'!
requiredJobsForSelectedMissionListSize
	^self requiredJobListModel list size! !

!TinyTowerGameController methodsFor: 'subs' stamp: 'HwaJong 2/23/2014 20:30'!
residentFloorController
	^residentFloorController setDefault: 
	#residentFloorControllerDefault for: self withSetter: #residentFloorController: afterSetOperation: #updateResidentFloorController.
! !

!TinyTowerGameController methodsFor: 'subs' stamp: 'HwaJong 2/23/2014 18:35'!
residentFloorController: aResidentFloorController 
	residentFloorController := aResidentFloorController! !

!TinyTowerGameController methodsFor: 'subs' stamp: 'HwaJong 3/1/2014 21:57'!
residentFloorControllerDefault
	^ResidentFloorController2 new ownerController: self! !

!TinyTowerGameController methodsFor: 'subs' stamp: 'HwaJong 2/23/2014 22:47'!
selectedBititzenMorph
	^selectedBititzenMorph setDefault: #selectedBititzenMorphDefault for: self withSetter: #selectedBititzenMorph:! !

!TinyTowerGameController methodsFor: 'subs' stamp: 'HwaJong 2/23/2014 22:48'!
selectedBititzenMorph: aBitizenMorph 
	selectedBititzenMorph := aBitizenMorph! !

!TinyTowerGameController methodsFor: 'subs' stamp: 'HwaJong 2/23/2014 22:48'!
selectedBititzenMorphDefault
	^BitizenMorph new! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 21:01'!
selectedMissionIsDone
	^self missionListModel 
		ifHasSelection: [:selection | selection isDone ] 
		ifDoesNotHaveSelection: [ false ]! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 17:37'!
selectedMissionIsDone: aBoolean 
	self missionListModel selection isDone: aBoolean.
	self changed: #missionListElementAt: ! !

!TinyTowerGameController methodsFor: 'action' stamp: 'HwaJong 3/1/2014 16:04'!
setOrClearJobOfSelectedBitizen
	|b|
	b := self bitizenListModel selection.
	b hasJob
		ifTrue: 
			[b beJobless]
		ifFalse: 
			[|cb|
			cb := ChooseFromBuilder new.
			cb title: 'select job'.
			model commercialFloorsNeedingBitizen do:
				[:each|
				cb choiceString: each job jobName value: [ b jobFloor: each ]].
			cb chooseFromValuesTitle].
	self changed: #bitizenListElementAt:.
	self changed: #jobFloorString.! !

!TinyTowerGameController methodsFor: 'list element' stamp: 'HwaJong 2/22/2014 03:35'!
sortBitizenDropList
	^self sortBitizenDropListModel list! !

!TinyTowerGameController methodsFor: 'get list index' stamp: 'HwaJong 2/22/2014 03:40'!
sortBitizenDropListIndex
	^self sortBitizenDropListModel selectionIndex! !

!TinyTowerGameController methodsFor: 'set list index' stamp: 'HwaJong 2/22/2014 03:45'!
sortBitizenDropListIndex: anInteger 
	self sortBitizenDropListModel selectionIndex: anInteger.
	self bitizenListModel: nil.
	self changed: #bitizenListSize.
	self changed: #bitizenListElementAt: ! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 2/22/2014 03:36'!
sortBitizenDropListModel
	^sortBitizenDropListModel setDefault: #sortBitizenDropListModelDefault for: self withSetter: #sortBitizenDropListModel:! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 2/22/2014 03:40'!
sortBitizenDropListModel: aTGListModel 
	sortBitizenDropListModel := aTGListModel! !

!TinyTowerGameController methodsFor: 'list model' stamp: 'HwaJong 2/24/2014 01:14'!
sortBitizenDropListModelDefault

	^TGListModel new
		list: 
		{ 
			PrintingDifferently subject: (UnarySortDescriptor ascendingBy: #bitName) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'name' ].
			PrintingDifferently subject: (UnarySortDescriptor ascendingBy: #happiness) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'happiness' ].
			PrintingDifferently subject: (UnarySortDescriptor descendingBy: #foodAbility) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'food' ].
			PrintingDifferently subject: (UnarySortDescriptor descendingBy: #serviceAbility) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'service' ].
			PrintingDifferently subject: (UnarySortDescriptor descendingBy: #recreationAbility) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'recreation' ].
			PrintingDifferently subject: (UnarySortDescriptor descendingBy: #retailAbility) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'retail' ].
			PrintingDifferently subject: (UnarySortDescriptor descendingBy: #creativeAbility) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'creative' ].
			PrintingDifferently subject: (UnarySortDescriptor descendingBy: #homeFloorNumber) printOnBlockWithSelfWithStream: [:me :stream | stream nextPutAll: 'home' ].
		 };
		selectionIndex: 1! !

!TinyTowerGameController methodsFor: 'set list index' stamp: 'HwaJong 3/2/2014 13:08'!
updateFloorController

	(self floorListModel selection isKindOf: ResidentFloor)
		ifTrue: 
			[self residentFloorController model: (self floorListModel selection).
			floorDetailTabMorph selectedPageIndex: 2].
	(self floorListModel selection isKindOf: CommercialFloor)
		ifTrue: 
			[self commercialFloorController model: (self floorListModel selection).
			floorDetailTabMorph selectedPageIndex: 1].! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/3/2014 13:38'!
updateFloorListItemAndDetailAfterAddingFloor
	self floorListModel: nil.
	self floorListModel selectionIndex: 1.
	self changed: #floorListSize.
	self changed: #floorListElementAt: .
	self updateFloorController! !

!TinyTowerGameController methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 20:59'!
updateResidentFloorController! !

Error subclass: #TTJobInUse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

Error subclass: #TTNoJobError
	instanceVariableNames: 'jobName game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyTower'!

!TTNoJobError methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2014 17:50'!
addJobAndRetry
	game addJobNamed: jobName.
	(game hasJobNamed: jobName)
		ifTrue: [ self retry ]! !

!TTNoJobError methodsFor: 'as yet unclassified ' stamp: 'HwaJong 2/15/2014 23:53'!
game
	^ game! !

!TTNoJobError methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 23:26'!
game: aTinyTowerGame 
	game := aTinyTowerGame ! !

!TTNoJobError methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 23:53'!
jobName
	^ jobName! !

!TTNoJobError methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/15/2014 23:16'!
jobName: aString 

	jobName := aString! !
